<!doctype html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Starter Template for Bootstrap</title>

    <!-- Bootstrap core CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.2/css/bootstrap.min.css" integrity="sha384-Smlep5jCw/wG7hdkwQ/Z5nLIefveQRIY9nfy6xoR1uRYBtpZgI6339F5dgvm/e9B"
        crossorigin="anonymous">

    <!-- Custom styles for this template -->
    <style>
        body {
            background-image: url('https://gitlab.com/brn.cortes/projeto-banco-nao-relacional/raw/master/assets/subtle_zebra_3d.png');
            text-align: justify;
        }

        .container-fluid {
            margin-top: 4rem;
            max-width: 1200px;
        }

        section {
            margin-top: 5rem;
            background: white;
        }

        h4 {
            margin-top: 2rem;
            margin-bottom: 1rem;
        }

        section {
            padding: 1rem 2rem;
            margin: 2rem;
            -webkit-box-shadow: 1px 1px 3px 1px rgba(196, 196, 196, 1);
            -moz-box-shadow: 1px 1px 3px 1px rgba(196, 196, 196, 1);
            box-shadow: 1px 1px 3px 1px rgba(196, 196, 196, 1);
            border-radius: 3px;
        }

        .anchor {
            position: relative;
            top: -4rem;
            visibility: hidden;
        }

        p,
        pre {
            margin-left: 1rem;
            margin-right: 1rem;
        }

        pre.prettyprint {
            display: inline-block !important;
            border-radius: 3px;
            padding-right: 1rem;
            padding-top: .5rem;
            padding-bottom: .5rem;
            -webkit-box-shadow: inset 1px 1px 3px 1px rgba(0, 0, 0, 0.39);
            -moz-box-shadow: inset 1px 1px 3px 1px rgba(0, 0, 0, 0.39);
            box-shadow: inset 1px 1px 3px 1px rgba(0, 0, 0, 0.39);
            max-width: 100%;
        }

        code {
            overflow-x: scroll !important;
        }

        li pre {
            margin-left: 0rem;
        }

        li.L0,
        li.L1,
        li.L2,
        li.L3,
        li.L5,
        li.L6,
        li.L7,
        li.L8 {
            list-style-type: decimal !important;
        }

        .navbar {
            color: white
        }

        @media (min-width: 768px) {
            .navbar-collapse {
                border-left: 1px dashed #FFFFFF33;
            }
        }

        .navbar .navbar-brand,
        p>code,
        li>code {
            color: tomato
        }

        .alert {
            max-width: 90%;
            margin-left: auto;
            margin-right: auto;
        }
    </style>

</head>

<body>

    <nav class="navbar navbar-expand-md navbar-dark bg-dark fixed-top">
        <span class="title">
            <a class="navbar-brand" href="#">Bruno Côrtes Amaral</a>
        </span>

        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarsExampleDefault" aria-controls="navbarsExampleDefault"
            aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarsExampleDefault">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item">
                    <a class="nav-link" href="#Cassandra" onclick="scroll('#Cassandra')">Cassandra </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="#PostgreSQL" onclick="scroll('#PostgreSQL')">PostgreSQL </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="#Elasticsearch" onclick="scroll('#Elasticsearch')">Elasticsearch</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="#Carga" onclick="scroll('#Carga')">Carga</a>
                </li>
            </ul>
        </div>
        <span class="d-none d-md-block">Ago/2018</span>
    </nav>

    <main role="main" class="container-fluid">
        <a class="anchor" id="Cassandra"></a>
        <section>
            <h1>Cassandra</h1>
            <hr/>

            <article>
                <h2>DDL</h2>
                <ul>
                    <li>
                        <p>Estrutura do keyspace</p>
                        <pre class="prettyprint linenums">
<code>CREATE KEYSPACE dicoms 
    WITH REPLICATION = {  
        'class' : 'SimpleStrategy',  
        'replication_factor' : 1
    };</code></pre>
                    </li>
                    <li>
                        <p>Estrutura da tabela</p>
                        <pre class="prettyprint linenums">
<code>CREATE TABLE dicom_repository (  
    "patient_id"            text,
    "study_instance_uid"    text,
    "series_instance_uid"   text,
    "sop_instance_uid"      text,
    "dicom_json"            text,
    "dicom_bin"             blob,

    PRIMARY KEY (
        ("patient_id"), "study_instance_uid", "series_instance_uid", "sop_instance_uid"
    )
); </code></pre>
                    </li>
                    <li>
                        <p>Indices secundários</p>
                        <pre class="prettyprint linenums">
<code>CREATE INDEX idxStudy ON dicoms.dicom_repository ("study_instance_uid");
CREATE INDEX idxSeries ON dicoms.dicom_repository ("series_instance_uid");
CREATE INDEX idxInstance ON dicoms.dicom_repository ("sop_instance_uid"); </code></pre>
                    </li>
                </ul>
            </article>
            <article>
                <h4>Justificativa para o DDL</h4>
                <p class='text-justify'>Optei por utilizar o
                    <code>patient_id</code> como chave de partição, para que todas as imagens de um paciente fique na mesma partição, otmizando
                    a recuperação. Já para as clustering columns escolhi as
                    <code>study_instance_uid</code>,
                    <code>series_instance_uid</code> e
                    <code>sop_instance_uid</code> como ordenação para os clusters.</p>
                <p> Como as três clustering columns não fazem parte da chave, tornou-se necessário a criação de indices secundários
                    para poder utilizar estas colunas na hora de filtrar os registros.</p>
                <p> Inicialmente pensei em utilizar a primary key abaixo, porém desta forma não era possível pesquisar por todas
                    as imagens de um usuário e também uma imagem específica, sem utilizar os demais campos da chave composta
                    no WHERE. E como os campos eram parte da PK, só era possível criar indice secundário para
                    <code>sop_instance_uid</code>
                </p>
                <pre class="prettyprint linenums">
<code>PRIMARY KEY (
    ("patient_id", "study_instance_uid", "series_instance_uid"), "sop_instance_uid" 
) </code></pre>
            </article>

            <article>
                <h2>Consultas</h2>
                <ol>
                    <li>
                        <p>Obtendo todas as imagens de um paciente</p>
                        <pre class="prettyprint linenums">
<code>SELECT * FROM dicom_repository WHERE "patient_id" = '900-00-1961';
</code></pre>
                    </li>
                    <li>
                        <p>Obtendo todas as imagens de um exame específico feito para um paciente específico</p>
                        <pre class="prettyprint linenums">
<code>SELECT * FROM dicom_repository
 WHERE "patient_id" = '900-00-1961'
   AND "study_instance_uid" = '1.3.6.1.4.1.9328.50.50.165429404613436780047444739484180811987';
</code></pre>
                    </li>
                    <li>
                        <p>Obtendo todas as imagens de uma séria vinculada a um exame específico, feito para um paciente específico
                        </p>
                        <pre class="prettyprint linenums">
<code>SELECT * FROM dicom_repository
 WHERE "patient_id" = '900-00-1961'
   AND "study_instance_uid" = '1.3.6.1.4.1.9328.50.50.165429404613436780047444739484180811987'
   AND "series_instance_uid" = '1.3.6.1.4.1.9328.50.50.13177376384483705864578017054057985223';
</code></pre>
                    </li>
                    <li>
                        <p>Obtendo uma imagem específica</p>
                        <pre class="prettyprint linenums">
<code>SELECT * FROM dicom_repository
 WHERE "sop_instance_uid" = '1.3.6.1.4.1.9328.50.50.124918704913834792553353254650926346878';
</code></pre>
                    </li>
                </ol>
            </article>
        </section>

        <a class="anchor" id="PostgreSQL"></a>
        <section>
            <h1>PostgreSQL</h1>
            <hr/>

            <article>
                <h4>Configuração do FDW</h4>
                <pre class="prettyprint linenums">
<code>CREATE SERVER dicoms_server FOREIGN DATA WRAPPER multicorn
OPTIONS (
    wrapper 'cassandra-fdw.CassandraFDW',
    hosts 'localhost',
    port '9042'
);

CREATE SCHEMA dicoms;
IMPORT FOREIGN SCHEMA dicoms FROM SERVER dicoms_server INTO dicoms;</code></pre>

                <p>Após a criação do FDW, criei uma view que utiliza funções de manipulação de JSON do próprio PostgreSQL, a
                    qual representa uma linha na tabela para cada tag/valor de uma imagem.</p>
                <pre class="prettyprint linenums">
<code>CREATE OR REPLACE VIEW dicoms.tags AS
    SELECT  dicom_repository.sop_instance_uid,
            json_object_keys(dicom_repository.dicom_json::json) AS tag,
            json_array_elements(json_extract_path(dicom_repository.dicom_json::json, VARIADIC ARRAY[json_object_keys(dicom_repository.dicom_json::json)]) -> 'Value'::text) AS "Value",
            json_extract_path(dicom_repository.dicom_json::json, VARIADIC ARRAY[json_object_keys(dicom_repository.dicom_json::json)]) -> 'vr'::text AS "VR"
    FROM dicoms.dicom_repository;</code></pre>
            </article>

            <article>
                <h2>Consultas</h2>
                <ol>
                    <li>
                        <p>Obtendo dados para cálculo da dose de radiação à qual um determinado paciente foi submetido durante
                            a execução de exames</p>
                        <pre class="prettyprint linenums">
<code>SELECT b.*
  FROM (SELECT sop_instance_uid FROM dicoms.tags WHERE tag = '00100020' AND "Value"::text = '"900-00-1961"') a
  JOIN dicoms.tags b ON a.sop_instance_uid = b.sop_instance_uid
 WHERE tag = any(array['00180060', '00181150', '00181151', '00189321', '00189345', '00181405']);
</code></pre>
                    </li>
                </ol>
            </article>
        </section>

        <a class="anchor" id="Elasticsearch"></a>
        <section>
            <h1>Elasticsearch</h1>
            <hr/>

            <article>
                <h4>Criação do Índice</h4>
                <p>Foi criado o index
                    <code>dicoms-index</code> colocando como propriedade do documento as tags exigidas para o filtro e utilizando um analyzer personalizado
                    o qual separa palavras que estão em camel case para tratar cenários que o analyzer padrão do elasticsearch
                    não trataria, como no caso do texto 'Neck^HeadNeckPETCT', cujo qual o analyzer padrão não conseguiria
                    pegar o 'head' e o personalizado consegue.</p>
                <div class="alert alert-warning">
                    <strong>Observação:</strong> Eu sei que com um
                    <code>synonym token filter</code> eu conseguiria fazer com que seja possivel pesquisar por
                    <b>'Computed Radiography'</b> e trazer os json que tem a tag
                    <b>'CR'</b>, até mesmo por que o domínio não é muito grande. Porém, devido ao tempo não cheguei a implementar.
                </div>
                <pre class="prettyprint linenums">
<code>curl -X PUT -H 'Content-Type: application/json' -i http://localhost:9200/dicoms-index/ --data '{
    "settings": {
        "analysis": {
            "analyzer": {
                "camel": {
                    "type": "pattern",
                    "pattern": "([^\\p{L}\\d]+)|(?<=\\D)(?=\\d)|(?<=\\d)(?=\\D)|(?<=[\\p{L}&&[^\\p{Lu}]])(?=\\p{Lu})|(?<=\\p{Lu})(?=\\p{Lu}[\\p{L}&&[^\\p{Lu}]])"
                }
            }
        }
    },
    "mappings": {
        "dicoms": {
            "properties": {
                "00080018": {
                    "type": "text"
                },
                "00080020": {
                    "type": "text"
                },
                "00100010": {
                    "type": "text"
                },
                "00081030": {
                    "type": "text",
                    "analyzer": "camel"
                },
                "0008103E": {
                    "type": "text",
                    "analyzer": "camel"
                },
                "00100030": {
                    "type": "text"
                },
                "00080060": {
                    "type": "text"
                }
            }
        }
    }
}'</code></pre>
            </article>
            <article>
                <h4>Ajustes no PostgreSQL para integrar com o Elasticsearch</h4>
                <p>Após a criação do índice, foi criado a FDW no postgres com a seguinte DDL.</p>
                <pre class="prettyprint linenums">
<code>CREATE SERVER elastic_server FOREIGN DATA WRAPPER multicorn
    OPTIONS (
        wrapper 'pg_es_fdw.ElasticsearchFDW'
    );


CREATE FOREIGN TABLE dicoms.dicom_indice(
    id text NULL COLLATE pg_catalog."default",
    "00080018" text NULL COLLATE pg_catalog."default",
    "00080020" text NULL COLLATE pg_catalog."default",
    "00100010" text NULL COLLATE pg_catalog."default",
    "00081030" text NULL COLLATE pg_catalog."default",
    "0008103E" text NULL COLLATE pg_catalog."default",
    "00100030" text NULL COLLATE pg_catalog."default",
    "00080060" text NULL COLLATE pg_catalog."default",
    query text NULL COLLATE pg_catalog."default",
    score numeric NULL
)
    SERVER elastic_server
    OPTIONS (host 'localhost', port '9200', index 'dicoms-index', type 'dicoms', rowid_column 'id', query_column 'query', score_column 'score');</code></pre>

                <p>E além do FDW, criei a função
                    <code>insert_elasticsearch()</code>, que recebe o SOPIntanceUID como parâmetro, faz uma busca na view
                    <code>tags</code> e monta uma string com o comando
                    <code>INSERT</code> que irá inserir o registro no Elasticsearch através da foreign table
                    <code>dicom_indice</code>. Essa função é chamada pelo script de dump.</p>

                <p>Explicando a função:</p>
                <ul>
                    <li>
                        <code>[16-17]</code> - Inicializa as strings, com as partes fixas do DML.</li>
                    <li>
                        <code>[19-23]</code> - Loop para cada tag/valor o
                        <code>SOPInstanceUID</code> passado por parâmetro da function.</li>
                    <li>
                        <code>[24]</code> - Coloca o nome da tag entre aspas.</li>
                    <li>
                        <code>[25-26]</code> - No caso da tag
                        <code>PatientName</code>, a rotina de dump acabou gravando ela como
                        <code>{"Alphabetic": "253456"}</code> e por causa disso foi necessário esse tratamento especial para pegar só a parte relevante.</li>
                    <li>
                        <code>[27-28]</code> - Subistiui as àspas duplas (") pelas simples (').</li>
                    <li>
                        <code>[32-33]</code> - Finaliza a montagem do DML e executa o comando.</li>
                </ul>

                <pre class="prettyprint linenums">
<code>CREATE OR REPLACE FUNCTION dicoms.insert_elasticsearch(
    sopinstanceuid text)
    RETURNS void
    LANGUAGE 'plpgsql'

    COST 100
    VOLATILE SECURITY DEFINER 
    SET search_path='"admin, pg_temp"'
AS $BODY$

DECLARE
    rec RECORD;
    insert_columns TEXT;
    insert_values TEXT;
BEGIN
    insert_columns = 'INSERT INTO dicoms.dicom_indice (';
    insert_values = ') values (';
    
    FOR rec IN SELECT *
                    FROM dicoms.tags
                    WHERE sop_instance_uid = $1
                    AND tag = any(array['00080018', '00080020', '00100010', '00081030', '0008103E', '00100030', '00080060'])
    LOOP
        insert_columns = insert_columns || '"' || rec.tag || '", ';
        IF (rec.tag = '00100010') THEN
                insert_values = insert_values || replace(json_extract_path(rec."Value", 'Alphabetic')::text, '"', '''') || ', ';
        ELSE
            insert_values = insert_values || replace(rec."Value"::text, '"', '''') || ', ';
        END IF;
    END LOOP;
                                        
    insert_values = insert_values || ');';
    EXECUTE replace(insert_columns || insert_values, ', )', ')');
END;

$BODY$;</code></pre>
            </article>

            <article>
                <h2>Consultas</h2>
                <ol>
                    <li>
                        <p>Recuperar o conteúdo das tags peak voltage (0018,0060), exposure time (0018,1150), tube current (0018,1151),
                            CT exposure sequence group (0018,9321), volume CT dose index (0018,9345), relative x - ray exposure
                            (0018,1405), para todos os exames de radi ologia computadorizada de 2017, considerando apenas
                            exames feitos para a região do tórax. Uma vez identificados os exames, suas imagens devem ser
                            recuperadas para visualização e estudo.</p>
                        <pre class="prettyprint linenums">
<code>SELECT a.sop_instance_uid, b.dicom_bin, a.tag, a."Value"
  FROM dicoms.tags a
  JOIN dicoms.dicom_repository b ON a.sop_instance_uid = b.sop_instance_uid
 WHERE tag = any(array['00180060', '00181150', '00181151', '00189321', '00189345', '00181405' ,'00181310'])
   AND a.sop_instance_uid IN (SELECT "00080018" 
                            FROM dicoms.dicom_indice 
                            WHERE query ='+00080060:CR +00080020:[20170101 TO 20171231] +(00081030:chest OR 0008103E:chest)');</code></pre>
                    </li>
                    <li>
                        <p>Na consulta abaixo, eu testei se a coluna onde tem a descrição do estudo está utilizando o anaylzer
                            e se o mesmo está se comportando da forma desejada.</p>
                        <pre class="prettyprint linenums">
<code>curl -X POST -H 'Content-Type: application/json' -i http://localhost:9200/dicoms-index/_analyze --data '{
    "field": "00081030", 
    "text":  "Neck^HeadNeckPETCT"
}'</code></pre>
                        <p>O qual retorna a seguinte response</p>
                        <pre class="prettyprint linenums">
<code>{
    "tokens": [{
        "token": "neck",
        "start_offset": 0,
        "end_offset": 4,
        "type": "word",
        "position": 0
    }, {
        "token": "head",
        "start_offset": 5,
        "end_offset": 9,
        "type": "word",
        "position": 1
    }, {
        "token": "neck",
        "start_offset": 9,
        "end_offset": 13,
        "type": "word",
        "position": 2
    }, {
        "token": "petct",
        "start_offset": 13,
        "end_offset": 18,
        "type": "word",
        "position": 3
    }]
}</code></pre>
                    </li>
                </ol>
            </article>
        </section>

        <a class="anchor" id="Carga"></a>
        <section>
            <h1>Carga</h1>
            <hr/>

            <article>
                <p>Para converter os arquivos DICOM para JSON, utilizei criei o script 'parse.sh', que varre os datasets e usa
                    o dcm2json para a conversão
                </p>
                <pre class="prettyprint linenums"><code>#!/bin/bash                                                                                                                                                                            
clear

#Pasta onde se encontra os arquivos .DCM
datasets=
#Pasta onde os JSON serão salvos
output=

rm -Rf $output
mkdir $output

count=0
find "$datasets" -type f -iname "*.dcm" -print0 | while IFS= read -r -d $'\0' line; do
    count=`expr $count + 1`           
    echo $line

    ~/dcm4che-5.13.3/bin/dcm2json "$line" > "$output/$count.json"
done    
</code></pre>

                <p>E para realizar a carga desses JSONs criados eu utilizei o script 'dump.sh' que utiliza o JQ para trabalhar
                    com JSON, e que executa as seguintes etapas:
                    <ul>
                        <li>Percorre os arquivos json do diretório, e para cada um deles...</li>
                        <li>Obtém o PatientID, o StudyInstanceUID, o SeriesInstanceUID, o SOPInstanceUID (e aplica um tratamento
                            na string retornada)</li>
                        <li>Obtém o binário original, através da tag '7FE00010', que contém a propriedade 'BulkDataURI' que armazena
                            o arquivo de onde o JSON foi gerado (Esta tag é adicionada automaticamente pelo dcm2json)</li>
                        <li>Grava um arquivo .cql contendo a DML para inserção de cada imagem e...</li>
                        <li>Em seguida, chama o cqlsh passando o arquivo .cql referente, o qual executará a DML criada no passo
                            anterior.
                        </li>
                        <li>E, por último, chama o psql fazendo um select na function responsável por inserir os registros no
                            índice do Elasticsearch.</li>
                    </ul>
                </p>
                <pre class="prettyprint linenums"><code> #!/bin/bash
clear

#Pasta onde estão os JSONs que seram persistidos
source=

rm -dfr cqls
mkdir cqls

i=1;
find "$source" -type f -iname "*.json" -print0 | while IFS= read -r -d $'\0' line; do
    echo $i && i=$((i+1));

    #Lê os valores dos atributos do JSON, e aplica tratamento na string, removendo trechos desnecessários, como áspas (") e os prefixo  e sufixo do caminho do arquivo binário.
    json=$(jq '.' $line)
    PatientID=$(jq '."00100020"."Value" | .[0]' $line)
    PatientID="$(echo $PatientID | sed -e 's/\"//g')"

    StudyInstanceUID=$(jq '."0020000D"."Value" | .[0]' $line)
    StudyInstanceUID="$(echo $StudyInstanceUID | sed -e 's/\"//g')"

    SeriesInstanceUID=$(jq '."0020000E"."Value" | .[0]' $line)
    SeriesInstanceUID="$(echo $SeriesInstanceUID | sed -e 's/\"//g')"

    SOPInstanceUID=$(jq '."00080018"."Value" | .[0]' $line)
    SOPInstanceUID="$(echo $SOPInstanceUID | sed -e 's/\"//g')"

    caminhoBinario=$(jq '."7FE00010"."BulkDataURI"' $line)
    caminhoBinario="$(echo $caminhoBinario | sed -e 's/\"file://g')"
    caminhoBinario="$(echo $caminhoBinario | sed -e 's/\?.*//g')"
    caminhoBinario="$(echo $caminhoBinario | sed -e 's/%20/ /g')"

    #Convente o arquivo para o formato hexadecimal
    binario=$(hexdump -x "$caminhoBinario")

    #Monsta a stirng de DML e grava em um arquivo para que o 'cqlsh' execute a instrução.
    #É necessário gravar no arquivo, pois se passar a string direto para o comando, ela estoura o limite do comando.
    insert="INSERT INTO dicom_repository (patient_id, study_instance_uid, series_instance_uid, sop_instance_uid, dicom_json, dicom_bin) VALUES ('$PatientID', '$StudyInstanceUID', '$SeriesInstanceUID', '$SOPInstanceUID', '$json', textAsBlob('$binario'));"
    echo $insert >> cqls/$SOPInstanceUID.cql && cqlsh -k dicoms -f "cqls/$SOPInstanceUID.cql" localhost 9042

    #Insere no Elasticsearch através da chamada da function 'insert_elasticsearch()' no PostgreSQL
    PGPASSWORD=postgres psql -U postgres -h localhost -w -c "SELECT dicoms.insert_elasticsearch('$SOPInstanceUID')"
done
</code></pre>
            </article>
        </section>

    </main>

    <p class="text-center">UNISUL - Universidade do Sul de Santa Catarina
        <br/>Pós Gaduação em Engenharia e Ciência de Dados
        <br/>Projeto de Banco de Dados Não Relacional</p>
    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
        crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49"
        crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.2/js/bootstrap.min.js" integrity="sha384-o+RDsa0aLu++PJvFqy8fFScvbHFLtbvScb8AjopnFD+iEQ7wo/CG0xlczd+2O/em"
        crossorigin="anonymous"></script>

    <script src="https://cdn.rawgit.com/google/code-prettify/master/loader/run_prettify.js?autoload=true&amp;skin=desert&amp;lang=css"></script>
</body>

</html>